
#include <iostream>
#include <chrono>

#include <mpi.h>
#include "./src/utils/MPIService.h"

using namespace std;

/*
 * Hlavni funkce aplikace
 *
 * @param argc pocet parametru
 * @param argv 1       - cesta k mezim (povinne)
 *             2       - cesta k sqlite databazi (povinne)
 *             3 a vic - parametry programu
 *                  -i<int>    - pocet interaci
 *                  -e<double> - hodnota pod kterou budeme brat vysledek
 *                  -m<double> - koeficien min dat
 */
int main(int argc, char **argv) {

    auto begin_ts1 = chrono::high_resolution_clock::now();

    int my_id, num_procs;

    MPI_Init(&argc, &argv);

    MPI_Comm_rank(MPI_COMM_WORLD, &my_id);
    MPI_Comm_size(MPI_COMM_WORLD, &num_procs);


    if(my_id == ROOT_PROCESS) {

        MPIService::master(argc, argv, num_procs, begin_ts1);

    } else {

        MPIService::slave(my_id);

    }

    MPI_Finalize();

    return 0;
}

