
#ifndef GLUCOSE_SERIAL_BOUNDS_H
#define GLUCOSE_SERIAL_BOUNDS_H

/*
 * Trida pro ulozeni mez parametru
 */
class Bounds {
public:
    /*
     * Konstruktor pro vytvoreni instance s defaultnima hodnotama
     * min = minimalni hodnota double
     * max = maximalni hodnota double
     */
    Bounds();

    /*
     * Vrati dolni mez parametru p
     *
     * @return dolni mez parametru p
     */
    double getPMin();
    /*
     * Nastavi dolni mez parametru p
     *
     * @param pMin hodnota dolni meze parametru p
     */
    void setPMin(double pMin);

    /*
     * Vrati horni mez parametru p
     *
     * @return horni mez parametru p
     */
    double getPMax();
    /*
     * Nastavi horni mez parametru p
     *
     * @param pMax hodnota horni meze parametru p
     */
    void setPMax(double pMax);

    /*
     * Vrati dolni mez parametru cg
     *
     * @return dolni mez parametru cg
     */
    double getCgMin();
    /*
     * Nastavi dolni mez parametru cg
     *
     * @param cgMin hodnota dolni meze parametru cg
     */
    void setCgMin(double cgMin);

    /*
     * Vrati horni mez parametru cg
     *
     * @return horni mez parametru cg
     */
    double getCgMax();
    /*
     * Nastavi horni mez parametru cg
     *
     * @param cgMax hodnota horni meze parametru cg
     */
    void setCgMax(double cgMax);

    /*
     * Vrati dolni mez parametru c
     *
     * @return dolni mez parametru c
     */
    double getCMin();
    /*
     * Nastavi dolni mez parametru c
     *
     * @param cMin hodnota dolni meze parametru c
     */
    void setCMin(double cMin);

    /*
     * Vrati horni mez parametru c
     *
     * @return horni mez parametru c
     */
    double getCMax();
    /*
     * Nastavi horni mez parametru c
     *
     * @param cMax hodnota horni meze parametru c
     */
    void setCMax(double cMax);

    /*
     * Vrati dolni mez parametru dt
     *
     * @return dolni mez parametru dt
     */
    double getDtMin();
    /*
     * Nastavi dolni mez parametru dt
     *
     * @param dtMin hodnota dolni meze parametru dt
     */
    void setDtMin(double dtMin);

    /*
     * Vrati horni mez parametru dt
     *
     * @return horni mez parametru dt
     */
    double getDtMax();
    /*
     * Nastavi horni mez parametru dt
     *
     * @param dtMax hodnota horni meze parametru dt
     */
    void setDtMax(double dtMax);

    /*
     * Vrati dolni mez parametru h
     *
     * @return dolni mez parametru h
     */
    double getHMin();
    /*
     * Nastavi dolni mez parametru h
     *
     * @param hMin hodnota dolni meze parametru h
     */
    void setHMin(double hMin);

    /*
     * Vrati horni mez parametru h
     *
     * @return horni mez parametru h
     */
    double getHMax();
    /*
     * Nastavi horni mez parametru h
     *
     * @param hMax hodnota horni meze parametru h
     */
    void setHMax(double hMax);

    /*
     * Vrati dolni mez parametru k
     *
     * @return dolni mez parametru k
     */
    double getKMin();
    /*
     * Nastavi dolni mez parametru k
     *
     * @param kMin hodnota dolni meze parametru k
     */
    void setKMin(double kMin);

    /*
     * Vrati horni mez parametru k
     *
     * @return horni mez parametru k
     */
    double getKMax();
    /*
     * Nastavi horni mez parametru k
     *
     * @param kMax hodnota horni meze parametru k
     */
    void setKMax(double kMax);

private:
    double _pMin;
    double _pMax;

    double _cgMin;
    double _cgMax;

    double _cMin;
    double _cMax;

    double _dtMin;
    double _dtMax;

    double _hMin;
    double _hMax;

    double _kMin;
    double _kMax;
};


#endif //GLUCOSE_SERIAL_BOUNDS_H
