
#ifndef GLUCOSE_SERIAL_FITNESSRESULT_H
#define GLUCOSE_SERIAL_FITNESSRESULT_H

#include "Parameters.h"

class FitnessResult {
public:
    /*
     * Vrati parametry pro ktery je tento vysledek
     *
     * @return parametry
     */
    Parameters getParameters();
    /*
     * Nastavi parametry k vysledku
     *
     * @param parameters parametry
     */
    void setParameters(Parameters parameters);

    /*
     * Vrati kolik bylo zpracovano dat
     *
     * @return pocet zpracovanych dat
     */
    int getNumberOfProcessedData();
    /*
     * Nastavi kolik dat bylo zpracovano
     *
     * @param numberOfProcessedData pocet zpracovanych dat
     */
    void setNumberOfProcessedData(int numberOfProcessedData);

    /*
     * Vrati celkovy pocet dat
     *
     * @return celkovy pocet dat
     */
    int getNumberOfData();
    /*
     * Nastavi celkovy pocet dat
     *
     * @param numberOfData celkovy pocet dat
     */
    void setNumberOfData(int numberOfData);

    /*
     * Vrati vhodnost parametru
     *
     * @return vhodnost parametru
     */
    double getFitness();
    /*
     * Nastavi vhopdnost parametru
     *
     * @param fitness vhodnost parametru
     */
    void setFitness(double fitness);
private:
    Parameters _parameters;
    int _count;
    int _countDat;
    double _fitness;
};


#endif //GLUCOSE_SERIAL_FITNESSRESULT_H
