
#ifndef GLUCOSE_SERIAL_PARAMETERS_H
#define GLUCOSE_SERIAL_PARAMETERS_H


/*
 * Trida pro ulozeni parametru
 */
class Parameters {
public:
    /*
     * ID parametru p
     */
    static const int P  = 0;
    /*
     * ID parametru cg
     */
    static const int CG = 1;
    /*
     * ID parametru c
     */
    static const int C  = 2;
    /*
     * ID parametru dt
     */
    static const int DT = 3;
    /*
     * ID parametru h
     */
    static const int H  = 4;
    /*
     * ID parametru k
     */
    static const int K  = 5;

    /*
     * Vrati hodnotu parametru p
     *
     * @return hodnota parametru p
     */
    double getP();
    /*
     * Nastavi hodnotu parametru p
     *
     * @param p hodnota parametru p
     */
    void setP(double p);

    /*
     * Vrati hodnotu parametru cg
     *
     * @return hodnota parametru cg
     */
    double getCg();
    /*
     * Nastavi hodnotu parametru cg
     *
     * @param cg hodnota parametru cg
     */
    void setCg(double cg);

    /*
     * Vrati hodnotu parametru c
     *
     * @return hodnota parametru c
     */
    double getC();
    /*
     * Nastavi hodnotu parametru c
     *
     * @param c hodnota parametru c
     */
    void setC(double c);

    /*
     * Vrati hodnotu parametru dt
     *
     * @return hodnota parametru dt
     */
    double getDt();
    /*
     * Nastavi hodnotu parametru dt
     *
     * @param dt hodnota parametru dt
     */
    void setDt(double dt);

    /*
     * Vrati hodnotu parametru h
     *
     * @return hodnota parametru h
     */
    double getH();
    /*
     * Nastavi hodnotu parametru h
     *
     * @param h hodnota parametru h
     */
    void setH(double h);

    /*
     * Vrati hodnotu parametru k
     *
     * @return hodnota parametru k
     */
    double getK();
    /*
     * Nastavi hodnotu parametru k
     *
     * @param k hodnota parametru k
     */
    void setK(double k);

    /*
     * Vrati pole s parametrama
     *
     * @return pole s parametrama
     */
    double* getParametersArray();

    /*
     * Nastavi hodnotu parametru podle ID parametru
     *
     * @param parameterId ID parametru
     * @param value hodnota parametru
     */
    void setParameter(int parameterId, double value);

private:
    double _parametersArray[6];
    double _p;
    double _cg;
    double _c;
    double _dt;
    double _h;
    double _k;
};


#endif //GLUCOSE_SERIAL_PARAMETERS_H
