//
// Created by 1Max11 on 21.12.2015.
//

#include "Segment.h"

int Segment::getId() {
    return _id;
}

void Segment::setId(int id) {
    _id = id;
}

vector<MeasuredValue *> Segment::getFilteredMeasuredValues() {
    return _filteredMeasuredValues;
}

vector<MeasuredValue*> Segment::getMeasuredValues() {
    return _measuredValues;
}


void Segment::setMeasuredValues(vector<MeasuredValue*> measuredValues) {
    _measuredValues = measuredValues;
    _filteredMeasuredValues.clear();

    vector<double> measuredat, ist;
    for (MeasuredValue *measuredValue : measuredValues) {
        // priprava udaju pro interpolaci
        if (measuredValue->getIst() != 0) {
            measuredat.push_back(measuredValue->getMeasuredat());
            ist.push_back(measuredValue->getIst());
        }
        // odstrani dat, kde neni krev namerena
        if (measuredValue->getBlood() != 0) {
            _filteredMeasuredValues.push_back(measuredValue);
        }
    }

    // nastaveni pro interpolaci ist podle casu
    AMeasuredat.setcontent(measuredat.size(), &(measuredat[0]));
    AIst.setcontent(measuredat.size(), &(ist[0]));
    spline1dbuildcubic(AMeasuredat, AIst, spline);
}

FitnessResult Segment::getResult() {
    return _result;
}

void Segment::setResult(FitnessResult result) {
    _result = result;
}

double Segment::getInterpolationIst(double measuredat) {
    return spline1dcalc(spline, measuredat);
}

int Segment::getNumberOfMinData() {
    return _numberOfMinData;
}

void Segment::setNumberOfMinData(int numberOfMinData) {
    _numberOfMinData = numberOfMinData;
}

