
#ifndef GLUCOSE_SERIAL_DATALOADER_H
#define GLUCOSE_SERIAL_DATALOADER_H

#include <string>
#include <vector>

#include "../model/Bounds.h"
#include "../model/Segment.h"


using namespace std;

/*
 * Trida se statickymi metodami pro nacteni dat
 */
class DataLoader {
public:
    /*
     * Metoda pro nacteni namerenych dat z databaze
     *
     * @param path cesta k sqlite souboru
     * @return vector odkazu na segment
     */
    static vector<Segment*> loadDataFromDatabase(string path);
    /*
     * Metoda pro nacteni mezi ze souboru
     *
     * @param path cesta k souboru
     * @return instance Bounds
     */
    static Bounds loadBounds(string path);
private:
    /*
     * Ziska ze stringu hodnotu parametru
     *
     * @param lines retezec
     * @string name jmeno hledaneho parametru
     * @return hodnota parametru
     */
    static double getParameterFromString(string lines, string name);
};

#endif //GLUCOSE_SERIAL_DATALOADER_H
