//
// Created by 1Max11 on 01.01.2016.
//

#ifndef GLUCOSE_MPI_MPISERVICE_H
#define GLUCOSE_MPI_MPISERVICE_H

#include <string>
#include <vector>
#include <chrono>
#include <mpi.h>

#include "../model/Segment.h"

#define ROOT_PROCESS 0

using namespace std;

/*
 * Trida obsahuje metody s kodem daneho uzlu
 */
class MPIService {
public:
    /*
     * Kod pro uzel s id 0
     *
     * @param argc pocet vstupnich parametru
     * @param argv parametry
     * @param num_proc pocet procesu
     * @param ts1 cas zacatku
     */
    static void master(int argc, char **argv, int num_procs, chrono::high_resolution_clock::time_point begin_ts1);
    /*
     * Kod pro uzel, ktery nema id 0
     *
     * @param my_id id uzlu
     */
    static void slave(int my_id);
private:
    /*
     * Odesle zpravu procesu
     *
     * @param message zprava pro odeslani
     * @param id id uzlu, kteremu se to ma odeslat
     */
    static void sendMessage(string message, int id);
    /*
     * Prijme zpravu od procesu
     *
     * @param id id uzlu
     * @param status status prijeti
     */
    static string recvMessage(int id, MPI_Status *status);
};


#endif //GLUCOSE_MPI_MPISERVICE_H
