//
// Created by 1Max11 on 27.12.2015.
//

#ifndef GLUCOSE_MPI_MESSAGE_H
#define GLUCOSE_MPI_MESSAGE_H


#include <vector>

#include "./../model/FitnessResult.h"
#include "./../model/MeasuredValue.h"
#include "./../model/Bounds.h"

using namespace std;

/*
 * Trida pro vytvareni zprav mezi procesy
 */
class Message {
public:
    /*
     * Vyrvori zpravu pro meze
     *
     * @param bounds odkaz na meze
     * @return zprava s mezema pro odeslani
     */
    static string createBoundsMessage(Bounds *bounds);
    /*
     * Prevede zpravu s mezema na objekt Bounds
     *
     * @pram message zprava s mezema
     */
    static Bounds* parseBoundsMessage(string message);

    /*
     * Vyrvori zpravu pro konfig
     *
     * @return zprava s konfigem
     */
    static string createConfigMessage();
    /*
     * Nastavi konfig programu
     *
     * @pram message zprava s konfigem
     */
    static void setConfigFromMessage(string message);

    /*
     * Vyrvori zpravu s namerenyma hodnotama
     *
     * @return zprava s namerenyma hodnotama
     */
    static string createMeasuredValueMessage(vector<MeasuredValue*> measuredValue);
    /*
     * Prevede zpravu s namerenyma hodnotama na vecotr objektu MeasuredValue
     *
     * @pram message zprava s namerenyma hodnotama
     */
    static vector<MeasuredValue*> parseMeasuredValueMessage(string message);

    /*
     * Vyrvori zpravu s vysledkem
     *
     * @return zprava s vysledkem
     */
    static string createFitnessMessage(FitnessResult *fitnessResult);
    /*
     * Prevede zpravu s vysledkem na objekt FitnessResult
     *
     * @pram message zprava s vysledkem
     */
    static FitnessResult* parseFitnessResultMessage(string message);

};


#endif //GLUCOSE_MPI_MESSAGE_H
