
#include "Storage.h"

#include "./../../include/sqlite/sqlite3.h"

void Storage::saveResultToDatabase(string path, vector<Segment*> segments) {
    sqlite3 *db;
    char *zErrMsg = 0;
    string sql = "";

    if (sqlite3_open(path.c_str(), &db)) {
        throw "SQL error: " + string(sqlite3_errmsg(db));
    }

    for (unsigned int i = 0; i < segments.size(); i++) {
        sql += "INSERT INTO difuse2params (p, cg, c, dt, h, k, s, segmentid) "  \
                    "VALUES ( " \
                        + to_string(segments[i]->getResult().getParameters().getP())  + "," \
                        + to_string(segments[i]->getResult().getParameters().getCg()) + "," \
                        + to_string(segments[i]->getResult().getParameters().getC())  + "," \
                        + to_string(segments[i]->getResult().getParameters().getDt()) + "," \
                        + to_string(segments[i]->getResult().getParameters().getH())  + "," \
                        + to_string(segments[i]->getResult().getParameters().getK())  + "," \
                        + "1," \
                        + to_string(segments[i]->getId()) + \
                    ");";
    }

    if (sqlite3_exec(db, sql.c_str(), NULL, 0, &zErrMsg) != SQLITE_OK ){
        sqlite3_free(zErrMsg);
        throw "SQL error: " + string(zErrMsg);
    }
    sqlite3_close(db);
}
