
#ifndef GLUCOSE_PARALLEL_THREADSMANAGER_H
#define GLUCOSE_PARALLEL_THREADSMANAGER_H

#include <pthread.h>

#include "./../model/ThreadStatistic.h"
#include "./../model/Segment.h"

/*
 * Trida, ktera sa stara o beh vlaken. Pocet vlaken je v Config.cpp.
 */
class ThreadsManager {
public:
    /*
     * Destruktor tridy
     */
    ~ThreadsManager();

    /*
     * Metoda spusti vlakna pro nalezeni parametru segmentu
     *
     * param segments vector odkazu na segmnety
     */
    void run(vector<Segment*> segments);

    /*
     * Vrati pole se statistikami o jednotlivych vlaken
     *
     * @return statistiky
     */
    ThreadStatistic** getStatistics();

private:

    static ThreadStatistic** _statistics;
    static unsigned int segmentId;
    static pthread_mutex_t mutex;
    static Segment* getNextSegment();
    static vector<Segment*> _segments;
    pthread_t* threads;
    /*
     * Vlakno
     */
    static void* runNelderMeadAlgorithm(void *threadId);
};


#endif //GLUCOSE_PARALLEL_THREADSMANAGER_H
