//
// Created by 1Max11 on 29.12.2015.
//

#ifndef GLUCOSE_MPI_PRINT_H
#define GLUCOSE_MPI_PRINT_H

#include <iostream>
#include <map>
#include <time.h>
#include <iomanip>

#include "../model/Segment.h"
#include "./DataLoader.h"
#include "./Storage.h"
#include "../NelderMeadAlgorithm.h"
#include "../model/Config.h"
#include "../model/ThreadStatistic.h"


class Print {
public:
    /*
     * Vypise udaje o aplikaci a nastavenych parametrech
     *
     * @param bounds meze parametru
     * @param boundsPath cesta k mezim
     * @param databasePath cesta k souboru s databazi
     */
    static void printHeader(Bounds* bounds, string boundsPath, string databasePath);

    /*
    * Vypise vysledky segmentu
    *
    * @param vector odkazu na segment
    */
    static void printResults(vector<Segment*> segments);

    /*
    * Vypise statistiky o vlaknech
    *
    * @param threadStatistic pole statistik o vlaknech
    * @param numberOfTreads pocet vlaken
    * @param ts doba behu seriove casti programu
    * @param tp doba behu paralelni casti programu
    */
    static void printStatistics(ThreadStatistic** threadStatistic, int numberOfTreads, int ts, int tp);

};


#endif //GLUCOSE_MPI_PRINT_H
